//+------------------------------------------------------------------+ 
//|    _TRO_RANGE_GAUGE                                              | 
//|                                                                  | 
//|   Copyright  2008, Avery T. Horton, Jr. aka TheRumpledOne       |
//|                                                                  |
//|   PO BOX 43575, TUCSON, AZ 85733                                 |
//|                                                                  |
//|   GIFTS AND DONATIONS ACCEPTED                                   | 
//|                                                                  |
//|   therumpledone@gmail.com                                        |  
//+------------------------------------------------------------------+ 

#property  copyright "Copyright  2008, Avery T. Horton, Jr. aka TRO" 
#property  link      "http://www.therumpledone.com/" 

#property indicator_chart_window


//---- input parameters 


extern int myChartY = 100 ;

extern int myChartPeriod = 1440 ;
extern int myBars        = 24 ;

extern string myFont  = "Courier" ; // "Verdana"
extern int myFontSize = 12 ; //9
 
extern color myColorH = LightSalmon ;
extern color myColor1 = LightSalmon ;
extern color myColor2 = LightSalmon ;
extern color myColor3 = LightSalmon ;
extern color myColor4 = LightSalmon ;
extern color myColor5 = LightSalmon ;
extern color myColor6 = LightSalmon ;
extern color myColor7 = LightSalmon ;
extern color myColor8 = LightSalmon ;
extern color myColor9 = LightSalmon ;
extern color myColor10 = LightSalmon ;

//---- buffers
 

int i;
   

double X01,X02,X03,X04,X05 ;
double X06 ;   
double X07 ;
double X08, X09, X10; 
double xRet, xRetBody, xRetWick, xRetTail ;
double xRetPct, xRetBodyPct, xRetWickPct, xRetTailPct;    
  
string symbol, tChartPeriod ;  
int    digits, period, win ; 
double point, open, high, low, close ;  

double  AvgRange, xRange, xBody, xWick, xTail, xTop, xBottom  ;


//+------------------------------------------------------------------+
  
int init()
  {

   if(myChartPeriod == 0) { myChartPeriod = Period() ; }    
   tChartPeriod =  TimeFrameToString(myChartPeriod) ;
   symbol       =  Symbol() ;
   digits       =  Digits ;
   point        =  Point ;
 
   win          = 0 ;
    
   return(0);
  }

//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+

int deinit()
  {
ObjectsDeleteAll( win, 21);
ObjectsDeleteAll( win, 22);
ObjectsDeleteAll( win, 23);     
   return(0);
  }


//+------------------------------------------------------------------+

int start()
{
  
open  = iOpen(NULL,myChartPeriod,0) ; 
high  = iHigh(NULL,myChartPeriod,0) ; 
low   = iLow(NULL,myChartPeriod,0) ; 
close = iClose(NULL,myChartPeriod,0) ;      
  
xRange = high - low ;
   
xTop    = MathMax(close,open) ;  
xBottom = MathMin(close,open) ;  
  
xRet    = MathAbs(close - low) ;
xRetPct = ( 100 * xRet ) / ( xRange );    

xRetWick    = high - xTop ;
xRetWickPct = ( 100 * xRetWick ) / ( xRange );   
       
xRetTail    = xBottom - low ;
xRetTailPct = ( 100 * xRetTail ) / ( xRange );   

xRetBody    = MathAbs(close - open) ;
xRetBodyPct = ( 100 * xRetBody ) / ( xRange );    

int limit = myBars + 1;

   for(int i=1; i<limit; i++) 
   { 

     double HighVal  = iHigh(NULL,myChartPeriod,i);        
     double LowVal   = iLow(NULL,myChartPeriod,i); 

     double Range    = HighVal - LowVal ; // range

     double tRange   = Range / point; // range
     
     double buf_tmp  =  buf_tmp + Range ;
          
   } 

     AvgRange = buf_tmp / myBars / point ; // average range 



DoShowGauge() ;

return(0); 
} 

//+------------------------------------------------------------------+ 

void DoShowGauge()
{

X01  = open ;
X02  = high ;
X03  = low ;
X04  = close ;
X05  = xRange / point;
X06  = xRetPct  ;
X07  = xRetWickPct  ;
X08  = xRetBodyPct ;
X09  = xRetTailPct ;
X10  = AvgRange ;

string StrH   = " Range Gauge" ;
string StrX01 = "Open   " ; 
string StrX02 = "High   " ; 
string StrX03 = "Low    " ; 
string StrX04 = "Close  " ;  
string StrX05 = "Range  " ; 
string StrX06 = "Ret%   " ;
string StrX07 = "Wick%  " ;
string StrX08 = "Body%  " ;  
string StrX09 = "Tail%  " ;  
string StrX10 = "Avg("+myBars+")" ;  
  
color color_X01=myColor1;
color color_X02=myColor2;
color color_X03=myColor3;  
color color_X04=myColor4;
color color_X05=myColor5;
color color_X06=myColor6;
color color_X07=myColor7;  
color color_X08=myColor8;  
color color_X09=myColor9;   
color color_X10=myColor10; 

double open1  = iOpen(NULL,myChartPeriod,1) ;
double high1  = iHigh(NULL,myChartPeriod,1) ; 
double low1   = iLow(NULL,myChartPeriod,1) ;    
double close1 = iClose(NULL,myChartPeriod,1) ;    
double range1 = high1 - low1 ;


if( open  > open1  ) { color_X01 = Lime ; } else { color_X01 = Red ; } 
if( high  > high1  ) { color_X02 = Lime ; } else { color_X02 = Red ; } 
if( low   > low1   ) { color_X03 = Lime ; } else { color_X03 = Red ; }   
if( close > close1 ) { color_X04 = Lime ; } else { color_X04 = Red ; } 
   
if( xRange > range1 ) { color_X05 = Lime ; } else { color_X05 = Red ; } 
   
if( xRetPct > 50.0 ) { color_X06 = Lime ; } else { color_X06 = Red ; }    
     	
if( AvgRange > xRange  ) { color_X10 = Lime ; } else { color_X10 = Red ; }      	
     	
//---- Set Pivots labels

   int WindowToUse;
   int Corner_line, Xdist_line;
   int Corner_text, Corner_vSRFP, Xdist_text, Xdist_vSRFP;
   int Ydist_line5;
   int Corner_pivots, Xdist_pivots, Ydist_pivots;
   int Ydist_X01, Ydist_X02, Ydist_X03, Ydist_X04, Ydist_X05, Ydist_X06, Ydist_X07, Ydist_X08, Ydist_X09, Ydist_X10 ;
  
   int YdistInc ;
   
    WindowToUse =  0;
    Corner_line = 1;
    Corner_text = 1; Corner_vSRFP = 1;
    Xdist_line = 21; Xdist_text = 93; Xdist_vSRFP = 23;
    Corner_pivots = 1; Xdist_pivots = 21; 
    
    Ydist_pivots = myChartY;  
    Ydist_line5 = Ydist_pivots + 11; YdistInc = 15 ;
    
    Ydist_X01 = Ydist_pivots + 25; 
    Ydist_X02 = Ydist_X01 + YdistInc; 
    Ydist_X03 = Ydist_X01 + YdistInc*2; 
    Ydist_X04 = Ydist_X01 + YdistInc*3; 
    Ydist_X05 = Ydist_X01 + YdistInc*4;
    Ydist_X06 = Ydist_X01 + YdistInc*5;    
    Ydist_X07 = Ydist_X01 + YdistInc*6;
    Ydist_X08 = Ydist_X01 + YdistInc*7;    
    Ydist_X09 = Ydist_X01 + YdistInc*8;    
    Ydist_X10 = Ydist_X01 + YdistInc*9;    

   ObjectCreate("SRFP", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("SRFP",tChartPeriod + StrH,myFontSize, myFont, myColorH);
   ObjectSet("SRFP", OBJPROP_CORNER, Corner_pivots);
   ObjectSet("SRFP", OBJPROP_XDISTANCE, Xdist_pivots);
   ObjectSet("SRFP", OBJPROP_YDISTANCE, Ydist_pivots);
   
   ObjectCreate("line5SRFP", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("line5SRFP","---------------",myFontSize, myFont, myColorH);
   ObjectSet("line5SRFP", OBJPROP_CORNER, Corner_line);
   ObjectSet("line5SRFP", OBJPROP_XDISTANCE, Xdist_line);
   ObjectSet("line5SRFP", OBJPROP_YDISTANCE, Ydist_line5);
   
   ObjectCreate("X01_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X01_LabelRGE",StrX01,myFontSize, myFont, myColor1 );
   ObjectSet("X01_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X01_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X01_LabelRGE", OBJPROP_YDISTANCE, Ydist_X01);
   
   ObjectCreate("X01_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X01_ValueRGE"," "+DoubleToStr(X01,digits),myFontSize, myFont, color_X01);
   ObjectSet("X01_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X01_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X01_ValueRGE", OBJPROP_YDISTANCE, Ydist_X01);
    
   ObjectCreate("X02_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X02_LabelRGE",StrX02,myFontSize, myFont, myColor2 );
   ObjectSet("X02_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X02_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X02_LabelRGE", OBJPROP_YDISTANCE, Ydist_X02);
   
   ObjectCreate("X02_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X02_ValueRGE"," "+DoubleToStr(X02,digits),myFontSize, myFont, color_X02);
   ObjectSet("X02_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X02_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X02_ValueRGE", OBJPROP_YDISTANCE, Ydist_X02);

   ObjectCreate("X03_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X03_LabelRGE",StrX03,myFontSize, myFont, myColor3 );
   ObjectSet("X03_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X03_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X03_LabelRGE", OBJPROP_YDISTANCE, Ydist_X03);
   
   ObjectCreate("X03_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X03_ValueRGE"," "+DoubleToStr(X03,digits),myFontSize, myFont, color_X03);
   ObjectSet("X03_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X03_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X03_ValueRGE", OBJPROP_YDISTANCE, Ydist_X03);

   ObjectCreate("X04_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X04_LabelRGE",StrX04,myFontSize, myFont, myColor4 );
   ObjectSet("X04_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X04_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X04_LabelRGE", OBJPROP_YDISTANCE, Ydist_X04);
   
   ObjectCreate("X04_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X04_ValueRGE"," "+DoubleToStr(X04,digits),myFontSize, myFont, color_X04);
   ObjectSet("X04_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X04_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X04_ValueRGE", OBJPROP_YDISTANCE, Ydist_X04);  
       
   
   ObjectCreate("X05_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X05_LabelRGE",StrX05,myFontSize, myFont, myColor5 );
   ObjectSet("X05_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X05_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X05_LabelRGE", OBJPROP_YDISTANCE, Ydist_X05);
   
   ObjectCreate("X05_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X05_ValueRGE"," "+DoubleToStr(X05,digits),myFontSize, myFont, color_X05);
   ObjectSet("X05_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X05_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X05_ValueRGE", OBJPROP_YDISTANCE, Ydist_X05);
    
   ObjectCreate("X06_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X06_LabelRGE",StrX06,myFontSize, myFont, myColor6 );
   ObjectSet("X06_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X06_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X06_LabelRGE", OBJPROP_YDISTANCE, Ydist_X06);
   
   ObjectCreate("X06_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X06_ValueRGE"," "+DoubleToStr(X06,digits),myFontSize, myFont, color_X06);
   ObjectSet("X06_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X06_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X06_ValueRGE", OBJPROP_YDISTANCE, Ydist_X06);

   ObjectCreate("X07_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X07_LabelRGE",StrX07,myFontSize, myFont, myColor7 );
   ObjectSet("X07_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X07_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X07_LabelRGE", OBJPROP_YDISTANCE, Ydist_X07);
   
   ObjectCreate("X07_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X07_ValueRGE"," "+DoubleToStr(X07,digits),myFontSize, myFont, color_X07);
   ObjectSet("X07_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X07_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X07_ValueRGE", OBJPROP_YDISTANCE, Ydist_X07);

   ObjectCreate("X08_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X08_LabelRGE",StrX08,myFontSize, myFont, myColor8 );
   ObjectSet("X08_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X08_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X08_LabelRGE", OBJPROP_YDISTANCE, Ydist_X08);
   
   ObjectCreate("X08_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X08_ValueRGE"," "+DoubleToStr(X08,digits),myFontSize, myFont, color_X08);
   ObjectSet("X08_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X08_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X08_ValueRGE", OBJPROP_YDISTANCE, Ydist_X08);  
  
   ObjectCreate("X09_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X09_LabelRGE",StrX09,myFontSize, myFont, myColor9 );
   ObjectSet("X09_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X09_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X09_LabelRGE", OBJPROP_YDISTANCE, Ydist_X09);
   
   ObjectCreate("X09_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X09_ValueRGE"," "+DoubleToStr(X09,digits),myFontSize, myFont, color_X09);
   ObjectSet("X09_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X09_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X09_ValueRGE", OBJPROP_YDISTANCE, Ydist_X09);  
   ObjectCreate("X10_LabelRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X10_LabelRGE",StrX10,myFontSize, myFont, myColor10 );
   ObjectSet("X10_LabelRGE", OBJPROP_CORNER, Corner_text);
   ObjectSet("X10_LabelRGE", OBJPROP_XDISTANCE, Xdist_text);
   ObjectSet("X10_LabelRGE", OBJPROP_YDISTANCE, Ydist_X10);
   
   ObjectCreate("X10_ValueRGE", OBJ_LABEL, WindowToUse, 0, 0);
   ObjectSetText("X10_ValueRGE"," "+DoubleToStr(X10,digits),myFontSize, myFont, color_X10);
   ObjectSet("X10_ValueRGE", OBJPROP_CORNER, Corner_vSRFP);
   ObjectSet("X10_ValueRGE", OBJPROP_XDISTANCE, Xdist_vSRFP);
   ObjectSet("X10_ValueRGE", OBJPROP_YDISTANCE, Ydist_X10);  
   
}

//+------------------------------------------------------------------+ 

string TimeFrameToString(int tf)
{
   string tfs;
   switch(tf) {
      case PERIOD_M1:  tfs="M1"  ; break;
      case PERIOD_M5:  tfs="M5"  ; break;
      case PERIOD_M15: tfs="M15" ; break;
      case PERIOD_M30: tfs="M30" ; break;
      case PERIOD_H1:  tfs="H1"  ; break;
      case PERIOD_H4:  tfs="H4"  ; break;
      case PERIOD_D1:  tfs="D1"  ; break;
      case PERIOD_W1:  tfs="W1"  ; break;
      case PERIOD_MN1: tfs="MN";
   }
   return(tfs);
}